<template>
    <article class="box">
        
            <h1 class="title is-5">Endereço</h1>
            <template v-if="selecting">
                <ShippingAddressSelector 
                    :addresses="localAddresses" 
                    :selectedAddress="selectedAddress"
                    @click="addressSelected"
                />
            </template>
            <template v-else-if="creating">
                <ShippingAddressCreator 
                    @cancel="creating = false"
                    @created="created"
                />
            </template>
            <template v-else>
                <template v-if="selectedAddress">
                    <p>
                        {{ selectedAddress.name }}<br>
                        {{ selectedAddress.address_1 }}<br>
                        {{ selectedAddress.city }}<br>
                        {{ selectedAddress.postal_code }}<br>
                        {{ selectedAddress.country.name }}
                    </p>
                    <br>
                </template>
                <div class="field is-grouped">
                    <div class="columns">
                        <div class="column">
                            <p class="control">
                                <a href="" class="button is-link" @click.prevent="selecting = true">Mudar endereço de envio</a>
                            </p>
                        </div>
                        <div class="column">
                            <p class="control">
                                <a href="" class="button is-link" @click.prevent="creating = true">Novo Endereço</a>
                            </p>
                        </div>
                    </div>
                </div>
            </template>
    </article>
</template>

<script>
    import ShippingAddressSelector from './ShippingAddressSelector'
    import ShippingAddressCreator from './ShippingAddressCreator'
    import { mapActions, mapGetters } from 'vuex'

    export default {
        components: {
            ShippingAddressSelector,
            ShippingAddressCreator
        },
        data() {
            return {
                selecting: false,
                creating: false,
                // addresses: [],
                localAddresses: this.addresses,
                selectedAddress: null
            }
        },

        watch: {
            selectedAddress(address) {
                this.$emit('input', address.id)
            },

            stateAddress(value) {
                this.$emit('toggleShipping', value)
            }
        },

        computed: {
            ...mapGetters({
                'shipping': 'cart/shipping'
            }),

            defaultAddress() {
                return this.localAddresses.find(a => a.default === true)
            },

            stateAddress() {
                return (this.creating === false && this.selecting === false) ? true : false
            }
        },

        methods: {
            ...mapActions({
                changeAddressDefault: 'cart/changeAddressDefault'
            }),

            addressSelected(address){
                localStorage.cep = address.postal_code
                this.switchAddress(address)
                this.changeAddressDefault(address.id)
                this.selecting = false
            },
            switchAddress(address){
                if(this.shipping){
                    localStorage.frete = this.shipping.price.replace('R$', '').trim();
                }
                if (address){
                    localStorage.cep = address.postal_code
                }
                this.selectedAddress = address
            },
            
            created(address) {
                this.localAddresses.push(address)

                this.creating = false

                this.switchAddress(address)

                this.$store.dispatch('address/getAddresses')
            }
        },

        created() {
            if (this.addresses.length){
                this.switchAddress(this.defaultAddress)
            }
        },

        props: {
            addresses: {
                type: Array,
                required: true
            }
        }
    }
</script>